<?php

include_once("htmlfuncs.php");
include_once("gxml.php");
include_once ("search.php");
include_once("logger.php");

function GetPurchaseURL($Associate, $ID, $Cart, $Hmac)
{
  $Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=get&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&CartId=$Cart&Hmac=$Hmac";
  
  return $Filename;
}

function AddToNewCart($Associate, $ASIN)
{
  //Add the item to a new Amazon Cart and save the return xml.
  $Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=add&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&Asin.$ASIN=1";
  $Obj = GXMLTree($Filename);
 
  //Parse the xml and get the CartID  
  $CartID      = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->CARTID[0]->Data;
  $HMAC        = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->HMAC[0]->Data;
  $PurchaseURL = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->PURCHASEURL[0]->Data;
  
  //Save the cart id to a cookie.
  setcookie("HMAC", urlencode($HMAC), time()+3600);
  setcookie("PURCHASEURL", urlencode($PurchaseURL), time()+3600);
  setcookie("CARTID", urlencode($CartID), time()+3600);

  return $PurchaseURL;  
}

function AddToExistingCart($Associate, $ASIN, $CartID, $HMAC)
{
  //Add the item to an existing cart Amazon Cart and save the return xml.     
  $Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=add&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&Asin.$ASIN=1&CartId=$CartID&Hmac=".urldecode($HMAC);
  //$Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=add&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&Asin.$ASIN=1&CartId=$CartID&Hmac=".$HMAC;
  $Obj = GXMLTree($Filename);

  //Don't need to retrieve the cart id it is already set in a cookie.
  $PurchaseURL = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->PURCHASEURL[0]->Data;

  if ($PurchaseURL == "")
  {
    $PurchaseURL =  GetPurchaseURL($Associate, $ASIN, $CartID, $HMAC);
  }

  setcookie("PURCHASEURL", urlencode($PurchaseURL), time()+3600);

  return $PurchaseURL;
}

function AddToCart($Associate, $ASIN, $CartID, $HMAC)
{
  //Add $ASIN to Log.
  LogT("C", $ASIN);
  
  $Result = "";
  if ($CartID == "" || $CartID == "0")
  {
    $Result = AddToNewCart($Associate, $ASIN);
  }
  else
  {   
    $Result = AddToExistingCart($Associate, $ASIN, $CartID, $HMAC);
  }
  return $Result;
}

//Get the search word.
  $Associate  = GetParam('Associate', 'thinkbling-20');
  $Category   = GetParam("Category", "books");
  $Keywords   = GetParam("Keywords", "harry%20potter");
  $ASIN       = GetParam("ASIN", "B00000JH6U");
  $Page       = GetParam("Page", "1");
  $CartID     = GetParam("CartID", "");//CARTID and HMAC are only passed as cookies
  $HMAC       = GetParam("HMAC", "");//CARTID and HMAC are only passed as cookies
  $Sort       = GetParam("Sort", "+salesrank");
  
  if ($ASIN != "")
  {
    $PurchaseURL = AddToCart($Associate, $ASIN, $CartID, $HMAC);
  }

  echo("<br>$ProductURL");
  echo("<CENTER>");
  echo(search($Associate,
              $Category,
              $Keywords,
              $Sort));
  echo("<TABLE WIDTH=\"100%\">");
  
  if ($PurchaseURL != "")
  {
    echo(TR("<TD COLSPAN=\"5\"><CENTER>The item has been added to your shopping cart.</CENTER></TD>"));
    echo(TDW("&nbsp;","49%").
         TDWC(href(IMG("tbimages/more.jpg"), "list.php?Page=$Page&Keywords=$Keywords&Associate=$Associate"), 125).
         TDC("or").
         TDWC(href(IMG("tbimages/buy.jpg"), $PurchaseURL), 125).
//         TDWC(href(IMG("tbimages/buy.jpg"), "purchase.php"), 125).
         TDW("&nbsp;","49%"));
  }
  else
  {
    echo(TRTD("<CENTER>There is currently a problem fetching the data from Amazon.com.<br>Please try again later.</CENTER>"));
  }
  echo("</TABLE>");  
  echo("</CENTER>");
?>
